/********************************************************************************
** CIS 15 BG-03
** Fall,   2003
***************
**
** Lab 4        Pointer Applications    20 Points
**
*************************************************

  Write a program that reads the size of an array from the keyboard. 
  The array is to be dynamically allocated in the heap. 
  Then the program reads integers from the keyboard into the array. 

  Modify the straight insertion sort from Chapter 8 so that it sorts
  the array into ascending order. 
  
  The program must not change the original array and must not create a
  copy of it. (See figure 10-25, page 515).

  Print the sorted array and the original array to a file, using the 
  following format:

  ==========   ===========   ============   
   ORIGINAL     ASCENDING     DESCENDING
  ==========   ===========   ============   
      50           20            100
      70           50             70
      20           50             70
     100           70             70
      70           70             50
      50           70             50
      70          100             20

  
  Data		:  Run  your program  twice:

    Test Data Set 1:

    10     here you enter the size of the array  
    10 10 30 30 40 50 50 50 60 60


    Test Data Set 2:

    25
    50 30 10 90 5 20 25 90 40 35 50 30 50 30 90 5 40 50 90 30 10 5 20 10 35

  NOTE: Use pointer notation throughout. Do not use an index to access the 
  elements in the array: use a pointer, as in the following example:
  ____________________________________________________________________
  YES

  int ary[10] = {10, 15, 10, 30, 40, 50, 60, 70, 80, 90 };

  int *pWalk;
  int *pLast;

  pLast = ary + 10 - 1;
  for( pWalk = ary; pWalk <= pLast; pWalk++ )
     printf( "%3d", *pWalk );

  _____________________________________________________________________
  NO

  int ary[10] = {10, 15, 10, 30, 40, 50, 60, 70, 80, 90 };

  int i;

  for( i = 0; i < 10; i++ )
     printf( "%3d", *(ary + i) );
 
****************************************
**
**  Written By:  First_Name Last_Name ???
**
**  Date: 2/6/02 - ???
**
********************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <crtdbg.h>

#define maxSize 100

/* Prototype Declarations */

void welcome  (void);

int getData (int array []);
void makeArray (int array [], int arrayPtrs [], int arraySize);
void sortAscending (int arrayPtrs [], int arraySize);
void printData (int array [], int arrayPtrs [], int arraySize);

void farewell (void);

int main (void)
{
/* Local Definitions */
	int arraySize;
	int array [maxSize];
	int arrayPtrs [maxSize + 1];

/* Statements */
   welcome ();
   
   arraySize = getData(array);
   makeArray(array, arrayPtrs, arraySize);
   sortAscending(arrayPtrs, arraySize);
   printData(array, arrayPtrs, arraySize);
   
   printf( _CrtDumpMemoryLeaks() ? "Memory Leak\n" : "No Leak\n");
   farewell ( );

   return 0;

} /* main */


/* ============================== welcome ==============================
	Prints a welcome message.
	   PRE  : nothing
	   POST : welcome message printed
*/
void welcome (void)
{
/*  Local Definitions */

/*  Statements */
	printf("\t\t LAB 4 - Pointer Applications\n\n");
	
	return;

} /* welcome */

/* ============================== farewell ==============================
	Prints a farewell message.
	   PRE  : nothing.
	   POST : farewell message printed
*/
void farewell (void)
{
	printf("\n\t\tEnd of the program!"
		   "\n\t\tHave a great day!\n");

	return;

} /* farewell */

int getData (int array [])
{
	int arraySize = 0;
	int n = 0;

	printf("\nArray Size (up to %d integers): ", maxSize);
	scanf("%d", &arraySize);
	printf("\n\nEnter the numbers in the array, one at a time\n\n");
	
	for (n = 1; n <= arraySize; n++)
	{
		printf("Enter number %d: ", n);
		scanf("%d", &array[n]);
	}
	printf("\n");
	return arraySize;
}

void makeArray (int array [], int arrayPtrs [], int arraySize)
{
	int n;

	for (n = 1; n <= arraySize; n++)
	{
		arrayPtrs[n] = array[n];
	}
	return;
}

void sortAscending (int arrayPtrs [], int arraySize)
{
	int current;
	int walker;
	int located;
	int temp;

	for (current = 1; current <=arraySize; current++)
	{
		located = 0;
		temp = arrayPtrs [current];
		for (walker = current - 1; walker >= 0 && !located;)
		{
			if (temp < arrayPtrs[walker])
			{
				arrayPtrs[walker + 1] = arrayPtrs [walker];
				walker--;
			}
			else
				located = 1;
		}
		arrayPtrs [walker+1] = temp;
	}
	return;
}

void printData (int array [], int arrayPtrs [], int arraySize)
{
	int i;
	int k;
	FILE *fpData;
	
	fpData = fopen("Data.txt", "w");
		

	fprintf(fpData, "==========   ===========   ============\n");  
	fprintf(fpData, " ORIGINAL     ASCENDING     DESCENDING\n");
	fprintf(fpData, "==========   ===========   ============\n");
k = arraySize;
	
	for (i = 1; i <= arraySize; i++)
	{
		fprintf(fpData, "%6d        %6d          %6d\n", array[i], arrayPtrs[i], arrayPtrs[k]);
		k--;
		
	}
	fclose (fpData);
	return;
}